#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2ten4search.py">
#<abstract4xi abstract = "shoots to direction ten"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2ten4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2ten4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2ten4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4ten

global count2ack4ten
global count2nack4ten
global count2found4ten
global count2short4ten

global current2series4ten
global candidate2series4ten

global fileobject4ten  

global keys2profile4ten
global key2profile4ten

global left2find4ten

global maxsize2ack4ten    
global maxsize2file4ten 
global max2short4ten
global meansize2ack4ten
global minsize2ack4ten

global ten2analyse4search

global profile2fetch4ten

global right2find4ten

global sumsize2ack4ten    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4ten = VersionKB4Xi['base2shoot4ten']             # base internet address, None=local url

count2ack4ten   = 0
count2nack4ten  = 0
count2found4ten = 0
count2short4ten = 0

left2find4ten = '('

max2short4ten = VersionKB4Xi['max2short4ten']
maxsize2file4ten = VersionKB4Xi['maxsize2file4ten']
maxsize2ack4ten  = 0
meansize2ack4ten = 0
minsize2ack4ten  = 0

current2series4ten = "current2series4ten5dummy"
candidate2series4ten  = "candidate2series4ten5dummy"


ten2analyse4search  = VersionKB4Xi['ten2analyse4search']

profile2fetch4ten = {}
profile2fetch4ten [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4ten [2] = '.jpg'
keys2profile4ten = profile2fetch4ten.keys()

right2find4ten = ')'

sumsize2ack4ten  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4ten" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4ten(target2explore4ten):
    global count2ack4ten
    global count2nack4ten
    global count2found4ten
    global count2short4ten
    
    global fileobject4ten 
       
    global keys2profile4ten
    global key2profile4ten
    
    global left2find4ten

    global max2short4ten    
    global maxsize2file4ten     
    global maxsize2ack4ten    
    global meansize2ack4ten
    global minsize2ack4ten
  
    global candidate2series4ten
    global current2series4ten
    
    
    global profile2fetch4ten                         # extension for files
    
    global right2find4ten
    
    global sumsize2ack4ten    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4ten = count2found4ten + 1
    ack2debug4ten = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4ten)
    
    ack2profile = False
    for key2profile4ten in keys2profile4ten:
        if name2target[1] == profile2fetch4ten[key2profile4ten]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2TEN4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4ten
        if ack2debug4ten is True:
            print("(STEP 0A/33) OF SHOOT2TEN4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2TEN4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4ten:
            count2nack4ten = count2nack4ten + 1
        else:
            count2ack4ten = count2ack4ten + 1
            sumsize2ack4ten = sumsize2ack4ten + size2file
            if size2file > maxsize2ack4ten:
                maxsize2ack4ten = size2file
            if ((size2file < minsize2ack4ten) or (minsize2ack4ten == 0)):
                print("(STEP 0B/33) OF SHOOT2TEN4SEARCH - USING MINSIZE2ACK4TEN: ", minsize2ack4ten, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4TEN:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2ten//d\tenfly29july2012\tenfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4TEN:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2ten//d\tenfly29july2012\tenfly29july2012 (2).JPG
                minsize2ack4ten = size2file
                print("(STEP 0C/33) OF SHOOT2TEN4SEARCH - SET MINSIZE2ACK4TEN TO: ", minsize2ack4ten, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4TEN TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2ten//d\tenfly29july2012\tenfly29july2012 (1).JPG
                # SET MINSIZE2ACK4TEN TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2ten//d\tenfly29july2012\tenfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4ten = target2explore4ten
            if ack2debug4ten is True:print("(STEP 1A/33) OF SHOOT2TEN4SEARCH - URL2WEB4TEN: ", url2web4ten) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4ten,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4ten = url2web4ten[0:index2edit] + string2use + url2web4ten[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4ten)
            shortname2web4ten = name2web[0]
            if ack2debug4ten is True:
                print("(STEP 1B/33) OF SHOOT2TEN4SEARCH - SHORTNAME2WEB4TEN: ", shortname2web4ten)
                # 
            
            string2find4ten = '/'
            ackall2found4ten = False           
            while 1:
                if ackall2found4ten is True:
                    break
                else:
                    index2find4ten=str.find(shortname2web4ten,string2find4ten)   
                    if index2find4ten == -1:
                        ackall2found4ten = True
                    else:
                        shortname2web4ten = shortname2web4ten[index2find4ten+1:]
                        
            if ack2debug4ten is True:            
                print("(STEP 1C/33) OF SHOOT2TEN4SEARCH - SHORTNAME2WEB4TEN: ", shortname2web4ten)
                # 
                
            ackall2found4ten = False 
            while 1:
                if ackall2found4ten is True:
                    break
                else:
                    index2left4ten=str.find(shortname2web4ten,left2find4ten)
                    if index2left4ten == -1:
                        current2series4ten = shortname2web4ten
                        if ack2debug4ten is True:
                            print("(STEP 2A/33) OF SHOOT2TEN4SEARCH - CURRENT2SERIES4TEN: ", current2series4ten) 
                            # 
                        ackall2found4ten = True
                         
                    else:
                        index2right4ten=str.find(shortname2web4ten,right2find4ten)
                        if index2right4ten == -1:
                            ackall2found4ten = True 
                        else:
                            candidate2series4ten = shortname2web4ten[0:index2left4ten]
                            
                            index3find4ten=str.find(shortname2web4ten,current2series4ten)
                            if index3find4ten == -1:
                                
                                current2series4ten = candidate2series4ten
                                if ack2debug4ten is True:
                                    print("(STEP 2B/33) OF SHOOT2TEN4SEARCH - CURRENT2SERIES4TEN: ", current2series4ten) 
                                    # 
                                
                                count2short4ten = 0
                                fileobject4ten.write('<br />' + '\n')
                            else:
                                shortname2web4ten = shortname2web4ten[index2left4ten:index2right4ten+1]
                                if ack2debug4ten is True:
                                    print("(STEP 2C/33) OF SHOOT2TEN4SEARCH - SHORTNAME2WEB4TEN: ", shortname2web4ten)
                                    # 
                                
                                count2short4ten = count2short4ten + 1
                                if count2short4ten >= max2short4ten:
                                    count2short4ten = 0
                                else:
                                    pass       
                            ackall2found4ten = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4ten is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4ten.write('<br /><b>&raquo;</b><a href="' + url2web4ten + '" target="_blank">' + shortname2web4ten + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4ten = ten2analyse4search
                if ack2debug4ten is True:
                    print("(STEP 3A/33) OF SHOOT2TEN4SEARCH - BASE2LOCAL4TEN: ", base2local4ten)
                    #              
                ack2localtries4ten = False                   
                while 1:
                    if ack2localtries4ten is True:
                        break
                    else:
                        index2find4ten=str.find(url2web4ten,base2local4ten)            
                        # 
                        #  
                        if index2find4ten == -1:
                            ack2localtries4ten = True
                        else:
                            if ack2debug4ten is True:
                                print("(STEP 3B/33) OF SHOOT2TEN4SEARCH - BASE2BUILD4TEN: ", base2build4ten)
                                # 
                            url2web4ten = base2build4ten + url2web4ten[len(base2local4ten):]
                            if ack2debug4ten is True:
                                print("(STEP 3C/33) OF SHOOT2TEN4SEARCH - URL2WEB4TEN: ", url2web4ten)
                                # 
                            
                            if count2short4ten < 1: 
                                fileobject4ten.write('<br /><b>&raquo;</b><a href="' + url2web4ten + '" target="_blank">' + shortname2web4ten + '</a>' + '\n')
                            else:
                                fileobject4ten.write('<b>&raquo;</b><a href="' + url2web4ten + '" target="_blank">' + shortname2web4ten + '</a>\n')                            
                            ack2localtries4ten = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2TEN4SEARCH FAILED, FILEOBJECT4TEN-WRITE-FAILED: ", str(fileobject4ten), time4xi())
      
    else:
        
        count2nack4ten = count2nack4ten + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2ten4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2ten4search(queue2ten = None, consumer_channel2ten = None, publisher_channel2ten = None, path2ten = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4ten
    global count2nack4ten
    global count2found4ten
    
    global fileobject4ten    
    
    global maxsize2ack4ten    
    global meansize2ack4ten
    global minsize2ack4ten
    global sumsize2ack4ten    
    
    global maxsize2file4ten 
    
    global profile2fetch4ten                         # extension for files
    global keys2profile4ten
    global key2profile4ten

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2TEN4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2TEN4SEARCH -  QUEUE2TEN: ", queue2ten)      
    # QUEUE2TEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2TEN4SEARCH -  CONSUMER_CHANNEL2TEN: ", consumer_channel2ten)
    # CONSUMER_CHANNEL2TEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2TEN4SEARCH -  PUBLISHER_CHANNEL2TEN: ", publisher_channel2ten)          
    # PUBLISHER_CHANNEL2TEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2ten is None) or (consumer_channel2ten is None) or (publisher_channel2ten is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2TEN4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2TEN4SEARCH - QUEUE2TEN: ", queue2ten)
        print("(STEP 1C/33) OF SHOOT2TEN4SEARCH - CONSUMER_CHANNEL2TEN: ", consumer_channel2ten) 
        print("(STEP 1D/33) OF SHOOT2TEN4SEARCH - PUBLISHER_CHANNEL2TEN: ", publisher_channel2ten)
        print("(STEP 1E/33) OF SHOOT2TEN4SEARCH - PATH2TEN: ", path2ten)     
        
        return
 
    if (not (queue2ten is None) and not(consumer_channel2ten is None) and not(publisher_channel2ten is None) and (path2ten is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2TEN4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2TEN4SEARCH - QUEUE2TEN: ", queue2ten)
        print("(STEP 2C/33) OF SHOOT2TEN4SEARCH - CONSUMER_CHANNEL2TEN: ", consumer_channel2ten) 
        print("(STEP 2D/33) OF SHOOT2TEN4SEARCH - PUBLISHER_CHANNEL2TEN: ", publisher_channel2ten)
        print("(STEP 2E/33) OF SHOOT2TEN4SEARCH - PATH2TEN: ", path2ten)     
        return           

    if (not (queue2ten is None) and not(consumer_channel2ten is None) and not(publisher_channel2ten is None) and not(path2ten is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2TEN4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2TEN4SEARCH - QUEUE2TEN: ", queue2ten)
        # QUEUE2TEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2TEN4SEARCH - CONSUMER_CHANNEL2TEN: ", consumer_channel2ten)
        # CONSUMER_CHANNEL2TEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2TEN4SEARCH - PUBLISHER_CHANNEL2TEN: ", publisher_channel2ten)
        # PUBLISHER_CHANNEL2TEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2TEN4SEARCH - PATH2TEN: ", path2ten)
        # PATH2TEN:  F://temp//yophotos//test2ten//
       
        print("(STEP 4A/33) OF SHOOT2TEN4SEARCH - STARTING TO WALK PATH2TEN: ", path2ten)   
        # STARTING TO WALK PATH2TEN:  F://temp//yophotos//test2ten//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4ten = None
        try:
            name2index4ten = "index2xxxxxxxx4yo.html"
            path2index4ten = path2ten + name2index4ten
            print("(Step 4B/33) OF SHOOT2TEN4SEARCH - SET PATH2INDEX4TEN TO: ", path2index4ten)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2TEN4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4TEN: ", path2index4ten)          
            #                    
        fileobject4ten = None
        try:
            fileobject4ten = open(path2index4ten,'w')
            print("(Step 4C/33) OF SHOOT2TEN4SEARCH - OPENED OUTPUT: ", fileobject4ten)
            # SHOOT2TEN4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2ten//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2TEN4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4ten)         
            # 
        try:                
            fileobject4ten.write('<html>\n')
            
            fileobject4ten.write('<style type="text/css" media="all">\n')
            fileobject4ten.write(' @import "http://www.yourtenxi.org/css/halongbay.css";\n')
            fileobject4ten.write('</style> \n')
            fileobject4ten.write('<p>\n')
            fileobject4ten.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4ten.write('<br /><a id="000">yourten<b>&Xi;</b> @Content</a>\n')
            fileobject4ten.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4ten.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2TEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4ten)         
            #      
        
        
        KB2name4ten = {}
        key2name4ten = 0
                 
        for file2walk in DirectoryWalker(path2ten):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4ten [key2name4ten] = file2walk
                    print ("KB2NAME4TEN[", key2name4ten, "]: ", KB2name4ten [key2name4ten])
                    # 
                    
                    key2name4ten = key2name4ten + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2TEN4SEARCH - FAILED UPDATING KB2NAME4TEN WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4ten(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4ten.write('<br /> \n')
            fileobject4ten.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4ten.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4ten.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4ten.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4ten.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4ten.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4ten.write('</p>\n')
            # 
            fileobject4ten.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2TEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4ten)         
            #            
        try:    
            fileobject4ten.close()
            print("(Step 4C/33) OF SHOOT2TEN4SEARCH - CLOSED OUTPUT: ", fileobject4ten)         
            # SHOOT2TEN4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2ten//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2TEN4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4ten)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2TEN4SEARCH - STARTING TO ANALYSE KB2NAME4TEN: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4TEN:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4ten  = {}
        AlphaKB4ten['a'] = {}
        AlphaKB4ten['b'] = {}
        AlphaKB4ten['c'] = {}
        AlphaKB4ten['d'] = {}
        AlphaKB4ten['e'] = {}
        AlphaKB4ten['f'] = {}
        AlphaKB4ten['g'] = {}
        AlphaKB4ten['h'] = {}
        AlphaKB4ten['i'] = {}
        AlphaKB4ten['j'] = {}
        AlphaKB4ten['k'] = {}
        AlphaKB4ten['l'] = {}
        AlphaKB4ten['m'] = {}
        AlphaKB4ten['n'] = {}
        AlphaKB4ten['o'] = {}
        AlphaKB4ten['p'] = {}
        AlphaKB4ten['q'] = {}
        AlphaKB4ten['r'] = {}
        AlphaKB4ten['s'] = {}
        AlphaKB4ten['t'] = {}
        AlphaKB4ten['u'] = {}
        AlphaKB4ten['v'] = {}
        AlphaKB4ten['w'] = {}
        AlphaKB4ten['x'] = {}
        AlphaKB4ten['y'] = {}
        AlphaKB4ten['z'] = {} 
        keys2AlphaKB4ten = AlphaKB4ten.keys()
        key2AlphaKB4ten  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4ten = len(path2ten)
        # 
        
        keys2name4ten = KB2name4ten.keys()
                
        for key2name4ten in sorted(keys2name4ten):
            # 
            name2optimize4ten = KB2name4ten[key2name4ten]
            # 
            shortcut2level4ten = name2optimize4ten[len2cut4ten:]
            # 
            len2shortcut4ten = len(shortcut2level4ten)
            if len2shortcut4ten == 1:
                try:
                    # LEVEL TEN CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4ten in keys2AlphaKB4ten:
                        KB2level1[key2level1] = shortcut2level4ten
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2TEN4SEARCH ** WARNING - SHORTCUT2LEVEL4TEN: ", shortcut2level4ten, " NOT IN KEYS2ALPHAKB4TEN: ", keys2AlphaKB4ten)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2TEN4SEARCH *** FAILED - SHORTCUT2LEVEL4TEN: ", shortcut2level4ten)      
            else:
                try:
                    
                    string2search4ten = '\\'
                    shortcut2level4ten = shortcut2level4ten[2:]
                    
                    index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                    if index2level4ten == -1:
                         
                        KB2level2[key2level2] = shortcut2level4ten
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                        index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                        if index2level4ten == -1:
                            KB2level3[key2level3] = shortcut2level4ten
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                            index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                            if index2level4ten == -1:
                                KB2level4[key2level4] = shortcut2level4ten
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                                index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                                if index2level4ten == -1:
                                    KB2level5[key2level5] = shortcut2level4ten
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                                    index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                                    if index2level4ten == -1:
                                        KB2level6[key2level6] = shortcut2level4ten
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                                        index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                                        if index2level4ten == -1:
                                            KB2level7[key2level7] = shortcut2level4ten
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4ten = shortcut2level4ten[index2level4ten+1:]
                                            index2level4ten=str.find(shortcut2level4ten,string2search4ten)
                                            if index2level4ten == -1:
                                                KB2level8[key2level8] = shortcut2level4ten
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2TEN4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4TEN: ", shortcut2level4ten)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2TEN4SEARCH *** FAILED - SHORTCUT2LEVEL4TEN: ", shortcut2level4ten)   
        
        print ("(Step 6A/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # tenfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2TEN4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2TEN4SEARCH - COUNT2ACK4TEN; ", count2ack4ten)
            # COUNT2ACK4TEN;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2TEN4SEARCH - COUNT2NACK4TEN; ", count2nack4ten)
            # COUNT2NACK4TEN;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2TEN4SEARCH - COUNT2FOUND4TEN: ", count2found4ten)
            # COUNT2FOUND4TEN:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2TEN4SEARCH - FOUND MAX SIZE: ", maxsize2ack4ten)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2TEN4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4ten)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4ten == 0:
                meansize2ack4ten = 0
                print ("(Step 7G1/33) OF SHOOT2TEN4SEARCH - MEAN SIZE SET: ", meansize2ack4ten)
                #  
            else:       
                meansize2ack4ten = int(sumsize2ack4ten / count2ack4ten)
                print ("(Step 7G2/33) OF SHOOT2TEN4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4ten, ", WHERE SUMSIZE2ACK4TEN: ", sumsize2ack4ten, " COUNT2ACK4TEN: ", count2ack4ten)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4TEN:  10944512  COUNT2ACK4TEN:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2TEN4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4ten < maxsize2file4ten:
                print ("(Step 7H/33) OF SHOOT2TEN4SEARCH - MIN SIZE MET: ", minsize2ack4ten)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2TEN4SEARCH ** MIN DEFINED: ", minsize2ack4ten, " EQUALS TO MAXSIZE2FILE4TEN: ", maxsize2file4ten)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2TEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2TEN4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2TEN4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2TEN4SEARCH - QUEUE2TEN: ", queue2ten)
        print("(STEP 7Z3/33) OF SHOOT2TEN4SEARCH - CONSUMER_CHANNEL2TEN: ", consumer_channel2ten) 
        print("(STEP 7Z4/33) OF SHOOT2TEN4SEARCH - PUBLISHER_CHANNEL2TEN: ", publisher_channel2ten)
        print("(STEP 7Z5/33) OF SHOOT2TEN4SEARCH - PATH2TEN: ", path2ten)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.tenxi.com; www.yourtenxi.com; www.yourtenxi.org; www.ten2xi.com/; www.ten4xi.com/; www.ten8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2ten4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
